unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FDosWnd: HWND;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  JclSysInfo;

function GetProcessWnd(const ProcessID: DWORD): HWND;
type
  PTopLevelWnd = ^TTopLevelWnd;
  TTopLevelWnd = record
    ProcessID: DWORD;
    Wnd: THandle;
  end;
var
  TopLevelWnd: TTopLevelWnd;

  function EnumWinProc(Wnd: THandle; Param: PTopLevelWnd): BOOL; stdcall;
  var
    PID: DWORD;
  begin
    GetWindowThreadProcessId(Wnd, @PID);
    if (PID = Param^.ProcessID) then
    begin
      Result := False;
      Param^.Wnd := Wnd;
    end
    else
      Result := True;
  end;

begin
  TopLevelWnd.ProcessID := ProcessID;
  TopLevelWnd.Wnd := 0;
  EnumWindows(@EnumWinProc, LPARAM(@TopLevelWnd));
  Result := TopLevelWnd.Wnd;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  FillChar(StartupInfo, SizeOf(TStartupInfo), #0);
  StartupInfo.cb := SizeOf(TStartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_HIDE;
  
  if CreateProcess(nil, PChar(Edit1.Text), nil, nil, False, NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo) then
  begin
    Sleep(0);
    WaitForInputIdle(ProcessInfo.dwProcessId, INFINITE);
    FDosWnd := GetProcessWnd(ProcessInfo.dwProcessId);

    if FDosWnd <> 0 then
    begin
      Windows.SetParent(FDosWnd, Panel1.Handle);
      SetWindowPos(FDosWnd, 0, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_SHOWWINDOW);
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  JclSysInfo.TerminateTask(FDosWnd, 100);
end;

end.

